Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY > Class Template Reference

Defines a Least Recently Used strategy which will decide on the item to be removed from the cache. More...

`#include <Caching_Strategies_T.h>`

Collaboration diagram for ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >:

[legend]
List of all members.

## Public Types
typedef ATTRIBUTES | CACHING_ATTRIBUTES
## Public Methods
| ACE_LRU_Caching_Strategy (void)
ATTRIBUTES | attributes (void)
| Accessor method for the timer attributes.
double | purge_percent (void)
| Get the percentage of entries to purge.
void | purge_percent (double percentage)
| Set the percentage of entries to purge.
int | notify_bind (int result, const ATTRIBUTES &attr)
int | notify_find (int result, ATTRIBUTES &attr)
int | notify_unbind (int result, const ATTRIBUTES &attr)
int | notify_trybind (int result, ATTRIBUTES &attr)
int | notify_rebind (int result, const ATTRIBUTES &attr)
CACHING_UTILITY & | caching_utility (void)
| Purge the cache.
void | dump (void) const
| Dumps the state of the object.
## Private Attributes
ATTRIBUTES | timer_
double | purge_percent_
| The level about which the purging will happen automagically.
CACHING_UTILITY | caching_utility_

## Detailed Description

### template<class ATTRIBUTES, class CACHING_UTILITY>
class ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >

Defines a Least Recently Used strategy which will decide on the item to be removed from the cache.

This is a strategy which makes use of a virtual timer which is updated whenever an item is inserted or looked up in the container. When the need of purging entries arises, the items with the lowest timer values are removed. Explanation of the template parameter list: CONTAINER is any map with entries of type <KEY, VALUE>. The ATTRIBUTES are the deciding factor for purging of entries and should logically be included with the VALUE. Some ways of doing this are: As being a member of the VALUE or VALUE being ACE_Pair<x, ATTRIBUTES>. The CACHING_UTILITY is the class which can be plugged in and which decides the entries to purge.

## Member Typedef Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
typedef ATTRIBUTES ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::CACHING_ATTRIBUTES

## Constructor & Destructor Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::ACE_LRU_Caching_Strategy | ( | void |  | ) |

| The <container> is the map in which the entries reside. The timer attribute is initialed to zero in this constructor. And the <purge_percent> field denotes the percentage of the entries in the cache which can be purged automagically and by default is set to 10%.

## Member Function Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE ATTRIBUTES ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::attributes | ( | void |  | ) |

| Accessor method for the timer attributes.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE CACHING_UTILITY & ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::caching_utility | ( | void |  | ) |

| Purge the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE void ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::dump | ( | void |  | ) | const

| Dumps the state of the object.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_bind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs bind method call.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_find | ( | int | result,
|  | ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs find method call

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_rebind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs rebind method call

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_trybind | ( | int | result,
|  | ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs trybind method call

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_unbind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs unbind method call

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE void ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::purge_percent | ( | double | percentage | ) |

| Set the percentage of entries to purge.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE double ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::purge_percent | ( | void |  | ) |

| Get the percentage of entries to purge.

## Member Data Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
CACHING_UTILITY ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::caching_utility_`[private]`

| This is the helper class which will decide and expunge entries from the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
double ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::purge_percent_`[private]`

| The level about which the purging will happen automagically.

template<class ATTRIBUTES, class CACHING_UTILITY>
ATTRIBUTES ACE_LRU_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::timer_`[private]`

| This element is the one which is the deciding factor for purging of an ITEM.

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Caching_Strategies_T.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Caching_Strategies_T.cpp
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Caching_Strategies_T.i